scala.tools.nsc.transform.patmat

# MatchCodeGen

#### trait MatchCodeGen extends Interface

Factory methods used by TreeMakers to make the actual trees.

We have two modes in which to emit trees: optimized (the default) and pure (aka "virtualized": match is parametric in its monad).

Linear Supertypes
Interface, TreeDSL, AnyRef, Any
Known Subclasses
MatchAnalysis, MatchApproximation, MatchOptimization, MatchTreeMaking, PatternMatching, patmat
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MatchCodeGen
2. Interface
3. TreeDSL
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait CodegenCore extends MatchMonadInterface

2. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `match`in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:``

3. #### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with OptimizedMatchMonadInterface

4. #### trait OptimizedMatchMonadInterface extends MatchMonadInterface

5. #### trait PureCodegen extends CodegenCore with PureMatchMonadInterface

6. #### trait PureMatchMonadInterface extends MatchMonadInterface

7. #### trait TypedSubstitution extends MatchMonadInterface

   Definition Classes
     Interface

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     TreeDSL

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (MatchCodeGen, B)

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to ArrowAssoc[MatchCodeGen] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

8. #### object CODE

   Definition Classes
     TreeDSL

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

12. #### final def devWarning(str: String): Unit

    Attributes
      protected
    Definition Classes
      Interface

13. #### def ensuring(cond: (MatchCodeGen) ⇒ Boolean, msg: ⇒ Any): MatchCodeGen

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (MatchCodeGen) ⇒ Boolean): MatchCodeGen

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): MatchCodeGen

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): MatchCodeGen

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

19. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

20. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

21. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

22. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

23. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

24. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

25. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

26. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

27. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

28. #### final def notify(): Unit

    Definition Classes
      AnyRef

29. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toString(): String

    Definition Classes
      AnyRef → Any

32. #### object vpmName

    Definition Classes
      Interface

33. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### def →[B](y: B): (MatchCodeGen, B)

    Implicit information
      This member is added by an implicit conversion from MatchCodeGen to ArrowAssoc[MatchCodeGen] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (matchCodeGen: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (matchCodeGen: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: MatchCodeGen

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to ArrowAssoc[MatchCodeGen] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (matchCodeGen: ArrowAssoc[MatchCodeGen]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: MatchCodeGen

   Implicit information
     This member is added by an implicit conversion from MatchCodeGen to Ensuring[MatchCodeGen] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (matchCodeGen: Ensuring[MatchCodeGen]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MatchCodeGen to StringAdd

### Inherited by implicit conversion any2stringfmt from MatchCodeGen to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from MatchCodeGen to ArrowAssoc[MatchCodeGen]

### Inherited by implicit conversion any2Ensuring from MatchCodeGen to Ensuring[MatchCodeGen]

### Ungrouped